package excersise2;

public abstract class Character {
	protected String name;	//名前
	protected int hp; //体力
	protected int ap; //攻撃力
	
	Character(String name, int hp, int ap){
		this.name = name;
		this.hp = hp;
		this.ap = ap;
	}
	
	//targetに攻撃する
	public void attack(Character target){
		System.out.println(name + " が " + target.getName() + " に攻撃!!");
		target.damage(this);	//引数として自分自身を渡す
	}
	
	//ステータスを表示
	public void putStatus(){
		System.out.println(name + " : ( " + hp + " , " + ap + " )");
	}
	
	//抽象メソッド
	abstract void damage(Character attacker);
	
	// getter
	String getName(){return name;}
	int getHp(){return hp;}
	int getAp(){return ap;}
}
